unit bddxml;
{ <description>

  Copyright (C) <2010> <Joly Alain of author> <jolyalain4@neuf.fr>

  This source is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This code is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  A copy of the GNU General Public License is available on the World Wide Web
  at <http://www.gnu.org/copyleft/gpl.html>. You can also obtain it by writing
  to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA.
}


{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics,
  XMLRead, DOM, StdCtrls, ExtCtrls, Menus, lHTTPUtil, lHTTP,
  ComCtrls, IniPropStorage,lNet, lNetComponents,  Typinfo;



 type
 TTextes = record
    Texte:string;
    LLabel:string;
 end;

 type
 TConditionMeteo = record
     Unite_Pression : string;
     Nuages:string;
     Date_Mesure:string;
     Unite_Temp:string;
     Icon_Jour:string;
     Humidite:TTextes;
     Visibilite:string;
     Temperature_Ressentie:TTextes;
     Temperature_LOW:TTextes;
     Temperature_HI:TTextes;
     Coucher_du_Soleil:TTextes;
     Lever_du_Soleil:TTextes;
     Etat_Pression:string;
     Pression:TTExtes;
     Temperature:TTextes;
     Ville_M:string;
     Latitude:string;
     Longitude:string;
     Station:TTextes;
     Vent:TTextes;
     Uv:TTextes;
 end;


type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    HTTPClient: TLHTTPClientComponent;
    BarStatus: TStatusBar;
    IniPropStorage: TIniPropStorage;
    Label1: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure HTTPClientDisconnect(aSocket: TLSocket);
    procedure HTTPClientDoneInput(ASocket: TLHTTPClientSocket);
    procedure HTTPClientError(const msg: string; aSocket: TLSocket);
    function HTTPClientInput(ASocket: TLHTTPClientSocket; ABuffer: pchar;
      ASize: integer): integer;
    procedure HTTPClientProcessHeaders(ASocket: TLHTTPClientSocket);

    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MenuItemClick(Sender: TObject);

    procedure CloseAppli(Sender: TObject);
   private
   HTTPBuffer: string;
    { private declarations }

    //procedure AppendToMemo(aMemo: TMemo; const aText: string);

  public
    { public declarations }

    function Traduire(Phrase: string): string;
    function Get_Generique_2(Nam:string;P1:string;P2:string):string;
    function Get_Generique_3(Nam:string;P1:string;P2:string;P3:string):string;

    procedure Request(vil:string);
    procedure Mise_a_jour;
    procedure AppendToMemo(aMemo: TMemo; const aText: string);
    procedure SendRequest(VILLE:string);
    procedure SetCaptionMenuItems(Index:Integer;V:TStringList);
    procedure Assigne_Meteo(Nam:string);

  end; 

var
  Form1: TForm1; 
  Doc:   TXMLDocument;
  Traductions : TStringList;
  Villes :   TStringList;
  VILLE:string;
  CondMeteo:  TConditionMeteo;
  MemoHTML:TMemo;
  MainMenu: TmainMenu;
  Imag:TImage;
  Lab:TLabel;
  chemin:string;
implementation

{ TForm1 }


function TForm1.Get_Generique_3(Nam:string;P1:string;P2:string;P3:string):string;
begin
     ReadXMLFile(Doc, Nam);
     result := Doc.DocumentElement.FindNode(P1).FindNode(P2).FindNode(P3).ChildNodes.Item[0].TextContent; Doc.Free;
end;

function TForm1.Get_Generique_2(Nam:string;P1:string;P2:string):string;
begin
     ReadXMLFile(Doc, Nam);
     result := Doc.DocumentElement.FindNode(P1).FindNode(P2).ChildNodes.Item[0].TextContent; Doc.Free;
end;

procedure TForm1.Assigne_Meteo(Nam:string);
begin
    CondMeteo.Coucher_du_Soleil.Texte:= Get_Generique_3(Nam,'dayf','day','suns'); CondMeteo.Coucher_du_Soleil.LLabel:='Coucher Du Soleil ';
    CondMeteo.Date_Mesure:= Get_Generique_2(Nam,'loc','tm');
    CondMeteo.Etat_Pression:=  Get_Generique_3(Nam,'cc','bar','d');
    CondMeteo.Humidite.Texte:= Get_Generique_2(Nam,'cc','hmid'); CondMeteo.Humidite.LLabel:='Humidité ';
    CondMeteo.Icon_Jour:= Get_Generique_2(Nam,'cc','icon');
    CondMeteo.Lever_du_Soleil.Texte:= Get_Generique_3(Nam,'dayf','day','sunr'); CondMeteo.Lever_du_Soleil.LLabel:='Lever du Soleil ';
    CondMeteo.Nuages:= Get_Generique_2(Nam,'cc','t');
    CondMeteo.Pression.Texte:= Get_Generique_3(Nam,'cc','bar','r'); CondMeteo.Pression.LLabel:='Pression ';
    CondMeteo.Temperature.Texte:= Get_Generique_2(Nam,'cc','tmp');CondMeteo.Temperature.LLabel:='Température ';
    CondMeteo.Temperature_HI.Texte:= Get_Generique_3(Nam,'dayf','day','hi');
    CondMeteo.Temperature_LOW.Texte:= Get_Generique_3(Nam,'dayf','day','low'); CondMeteo.Temperature_LOW.LLabel:='Température Prévue (Nuit) ';
    CondMeteo.Temperature_Ressentie.Texte:=  Get_Generique_2(Nam,'cc','flik'); CondMeteo.Temperature_Ressentie.LLabel:='Température Ressentie ';
    CondMeteo.Visibilite:= Get_Generique_2(Nam,'cc','vis');
    CondMeteo.Ville_M:=  Get_Generique_2(Nam,'loc','dnam');
    CondMeteo.Latitude:= Get_Generique_2(Nam,'loc','lat');
    CondMeteo.Longitude:=  Get_Generique_2(Nam,'loc','lon');
    CondMeteo.Station.Texte:= Get_Generique_2(Nam,'cc','obst') + '  ' + Get_Generique_2(Nam,'cc','lsup');  CondMeteo.Station.LLabel:='Station de ';
    CondMeteo.Unite_Temp:= Get_Generique_2(Nam,'head','ut');
    CondMeteo.Unite_Pression:= Get_Generique_2(Nam,'head','up');
    CondMeteo.Vent.Texte:= Get_Generique_3(Nam,'cc','wind','t');  CondMeteo.Vent.LLabel:= 'Vent ';
    CondMeteo.Uv.Texte:= Get_Generique_3(Nam,'cc','uv','i');  CondMeteo.Uv.LLabel:= 'Indice UV ';
end;


function TForm1.Traduire(Phrase: string): string;
var
  i : integer;
begin
  Result := Phrase;
  i := Pos(' ', Phrase); // Chercher 1er mot
  if (i > 3) and (SameText(Copy(Phrase, i-2,2), 'ed')) then
    // 1er mot se termine par 'ed' -> le mettre à la fin avant traduction
    Result := RightStr(Result, Length(Result)-i) +' '+ LeftStr(Phrase, i);
  with Traductions do
    for i := 0 to Count-1 do
      Result := StringReplace(Result, Names[i], Values[Names[i]], [rfReplaceAll,rfIgnoreCase]);
  // Mettre 1er lettre en majuscule
  if Result > '' then
    Result[1] := Upcase(Result[1]);
end;

procedure TForm1.Mise_a_jour;
//var

//HSun1:THSunRecord;
begin

     chemin := ExtractFileDir(Application.Exename);
     Traductions := TStringList.Create;
     Traductions.LoadFromFile(ExtractFileDir(Application.Exename)+'/Dictionnaire.ini');

     Assigne_Meteo(chemin + '/weather.xml');

     //HSun1:=Get_SunTime(StrToDate(DateToStr(Now)),StrToFloat(CondMeteo.Latitude),StrToFloat(CondMeteo.Longitude),0);

     Form1.Caption:= 'Météo du ' + DateToStr(Now) + '   ' + TimeToStr(StrToTime(CondMeteo.Date_Mesure)) + '    ' + 'Version 0.20';
     Label1.Caption :=  CondMeteo.Ville_M;
     Label2.Caption :=  CondMeteo.Temperature.LLabel + CondMeteo.Temperature.Texte + '°' + CondMeteo.Unite_Temp;
     Label3.Caption :=  CondMeteo.Temperature_Ressentie.LLabel + CondMeteo.Temperature_Ressentie.Texte + '°' + CondMeteo.Unite_Temp;
     Label4.Caption :=  CondMeteo.Temperature_LOW.LLabel + CondMeteo.Temperature_LOW.Texte + '°' + CondMeteo.Unite_Temp;
     Label5.Caption :=  CondMeteo.Pression.LLabel + CondMeteo.Pression.Texte + ' ' + CondMeteo.Unite_Pression + ' ' + Traduire(CondMeteo.Etat_Pression) ;
     Label6.Caption :=  CondMeteo.Lever_du_Soleil.LLabel + TimeToStr(StrToTime(CondMeteo.Lever_du_Soleil.Texte)); // + '   ' +  TimeToStr(HSun1.SAubeReel);
     Label7.Caption :=  CondMeteo.Coucher_du_Soleil.LLabel + TimeToStr(StrToTime(CondMeteo.Coucher_du_Soleil.Texte)); // + '   ' +  TimeToStr(HSun1.SCrepReel);
     Label8.Caption :=  CondMeteo.Humidite.LLabel + CondMeteo.Humidite.Texte  + ' %';
     Label9.Caption :=  Traduire(CondMeteo.Nuages);Imag.Picture.PNG.LoadFromFile( chemin + '/icons/' + CondMeteo.Icon_Jour+ '.png');
     Label10.Caption:=  CondMeteo.Station.LLabel +  CondMeteo.Station.Texte;
     Label11.Caption:=  CondMeteo.Vent.LLabel  + CondMeteo.Vent.Texte;
     Label12.Caption:=  CondMeteo.Uv.LLabel  + CondMeteo.Uv.Texte;

     Traductions.Free;

end;

procedure TForm1.FormActivate(Sender: TObject);
begin
     VILLE:= Edit1.Text ;
     if VILLE = '' then VILLE:=Villes.Values[Villes.Names[0]];
     Request(VILLE);
end;



procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
       Edit1.Text:=VILLE;
       Villes.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   Edit1.Text :=VILLE;
   Button1.Enabled:=False;
end;


procedure TForm1.SetCaptionMenuItems(Index:Integer;V:TStringList);
var
I:Integer;
O:Tobject;
begin
     For I:=0 to ComponentCount -1 do
     Begin
          O:= Components[I];
          if O.ClassName = 'TMenuItem' then
             begin
             if GetOrdProp(O,'Tag') <> 0 then
                begin
                  if GetOrdProp(O,'Tag') = Index then
                     begin
                     if V.Names[Index-1] <> '' then
                        begin
                        SetStrProp(O,'Caption',V.Names[Index-1]);
                        SetOrdProp(O,'Visible',1);
                        end;
                     end;
                end;
             end;
     end;


end;

procedure TForm1.FormCreate(Sender: TObject);
var
i,pos:integer;
SubMenu,Elem:TMenuItem;
begin
     // Create Memo pour recevoir les Datas HTML
     MemoHTML:=TMemo.Create(self);
     MemoHTML.Clear;
     Villes := TStringList.Create;
     Villes.LoadFromFile(ExtractFileDir(Application.Exename)+'/villes.ini');


     MainMenu:=TmainMenu.Create(self);
     SubMenu:=TMenuItem.Create(self);
     SubMenu.Caption:='Villes';
     MainMenu.Items.Insert(0,SubMenu);

     I:=1;
     while i <= Villes.Count -1 do
     begin
          Elem:=TMenuItem.Create(self);
          Elem.Caption:=Villes.Names[i-1];
          Elem.Tag:=I;
          Elem.OnClick:=@MenuItemClick;
          Elem.GroupIndex:=1;
          Elem.Visible:=True;

          SubMenu.Insert(SubMenu.Count,Elem); I+=1;
     end;

     Elem:=TMenuItem.Create(self);
     Elem.Caption:='-';
     Elem.GroupIndex:=1;
     Elem.GroupIndex:=1;
     Elem.Visible:=True;
     SubMenu.Insert(SubMenu.Count,Elem);

     Elem:=TMenuItem.Create(self);
     Elem.Caption:='Quitter';
     Elem.Tag:=I;
     Elem.OnClick:=@CloseAppli;
     Elem.GroupIndex:=1;
     Elem.Visible:=True;
     SubMenu.Insert(SubMenu.Count,Elem);

     Imag:=TImage.Create(self);
     //Imag.Stretch:=True;
     Imag.AutoSize:=True;
     Imag.Top:=60;
     Imag.Left:=30;
     Imag.Align:= alNone;
     self.InsertControl(Imag);

end;

procedure TForm1.CloseAppli(Sender: TObject);
begin
  Close;
end;

procedure TForm1.MenuItemClick(Sender: TObject);
var
I:Integer;
begin
     I:=GetOrdProp(Sender,'Tag');
     VILLE:=Villes.Values[Villes.Names[I-1]];
     Request(VILLE);
     Button1.Enabled:=True;
end;

// Recupere les Infos sur le site Weather.com
procedure TForm1.Request(vil:string);
var
demande:string;
begin
     //http://xoap.weather.com/search/search?where='+Localite
     //http://xoap.weather.com/weather/local/FRPA0035?r&cc=*&unit=m&dayf=9&prod=xoap&par=1003960698&key=8d4b00356ecc089d
     demande:= 'http://xoap.weather.com/weather/local/' + vil + '?r&cc=*&unit=m&dayf=9&prod=xoap&par=1003960698&key=8d4b00356ecc089d' ;
     SendRequest(demande);
end;



// HTML CONNECT DATA
// Par le biais d'un WEB-SERVICES, on recupere les Infos sur le site Weather.com

procedure TForm1.HTTPClientDisconnect(aSocket: TLSocket);
begin
  chemin := ExtractFileDir(Application.Exename);
  MemoHTML.Lines.SaveToFile(chemin +'/weather.xml');
  Mise_a_jour;
  BarStatus.SimpleText:= 'Déconnecté du site xoap.weather.com';
end;

procedure TForm1.HTTPClientDoneInput(ASocket: TLHTTPClientSocket);
begin
     aSocket.Disconnect;
     BarStatus.SimpleText:= 'Fini.';
end;

procedure TForm1.HTTPClientError(const msg: string; aSocket: TLSocket);
begin
     BarStatus.SimpleText:= msg + ' Erreur...';
end;

function TForm1.HTTPClientInput(ASocket: TLHTTPClientSocket; ABuffer: pchar;
ASize: integer): integer;
var
  oldLength: longint;
begin
  oldLength := Length(HTTPBuffer);
  setlength(HTTPBuffer,oldLength + ASize);
  move(ABuffer^,HTTPBuffer[oldLength + 1], ASize);
  MemoHTML.Text := HTTPBuffer;
  MemoHTML.SelStart := Length(HTTPBuffer);
  BarStatus.SimpleText:= IntToStr(ASize) + '...';
  Result := aSize;
end;


procedure TForm1.AppendToMemo(aMemo: TMemo; const aText: string);
begin
  aMemo.Append(aText);
  aMemo.SelStart := Length(aMemo.Text);
end;

procedure TForm1.SendRequest(VILLE:string);
var
  aHost, aURI: string;
  aPort: Word;
begin
  HTTPBuffer := '';
  DecomposeURL(VILLE, aHost, aURI, aPort);
  HTTPClient.Host := aHost;
  HTTPClient.URI  := aURI;
  HTTPClient.Port := aPort;
  HTTPClient.SendRequest;
end;

procedure TForm1.HTTPClientProcessHeaders(ASocket: TLHTTPClientSocket);
begin
   BarStatus.SimpleText:= 'Réponse: ' + IntToStr(HTTPStatusCodes[ASocket.ResponseStatus]) + ' ' + ASocket.ResponseReason;
end;


initialization
  {$I bddxml.lrs}

end.

